#include "main.h"
#include <xc.h>
#include "uart.h"

void Initial(void)
{
    // Oscillator configuration
    //Using internal oscillator with FRCDIV (8Mhz oscillator divided to 4 MHz)

    // I/O Port configuration
    PORTA = 0b0000000000000000;  //Set initial value for PORTA
    TRISA = 0b1111111111111111;  //Set I/O for PORTA as input (1) or output (0)

    PORTB = 0b0000000000000000;  //Set initial value for PORTB
    TRISB = 0b1111111111111111;  //Set I/O for PORTB as input (1) or output (0)

    // disable analog inputs (use digital)
    ANSA = 0;
    ANSB = 0;

    
            
    //TRISBbits.TRISB7 = 0;   // RB7 is an output for U1TX
    GPIO0_TRIS = 1;
    GPIO1_TRIS = 1;
    GPIO2_TRIS = 1;

    LED_TRIS = 0;             // set LED to output
    
    init_uart();

    IFS1bits.CNIF = 0;  // clear input change interrupt flag
    //IEC1bits.CNIE = 1;  // enable input change interrupt
    IPC4bits.CNIP = 7;  // set interrupt priority to max



    // ADC init
    AD1CON1bits.SSRC = 0b0111;       // clearing SAMP bit ends sampling and beings conversion
    AD1CON1bits.ASAM = 1;       // sampling immediately after conversion

    AD1CON2bits.PVCFG = 0b00;   // use AVdd as ref
    AD1CON2bits.SMPI = 0;       // interrupt at each conversion

    AD1CON3bits.ADCS = 0;
    AD1CON3bits.SAMC = 31;//0b0100;  // auto sample time = 4 * TAD

    AD1CHSbits.CH0SA = 0b01001; // input to ADC is AN9
    ANSBbits.ANSB15 = 1;    // AN9 (RB15) set to analog mode
    //IFS0bits.AD1IF = 0;
    //IEC0bits.AD1IE = 1;
}

void initTimers()
{
    // TIMER 1 PERIOD  = 0.262s   (1/2e6*8*65536)
    IEC0bits.T1IE = 1;          // timer 1 interrupt enable
    IPC0bits.T1IP = 6;      // timer 1 interrupt priority
    T1CONbits.TCKPS = 1;     // clock prescale is 1:8
    T1CONbits.TON = 1;          // enable timer 1

    T1CONbits.TCKPS = 0b10;     // clock prescale is 1:64
    //PR1 = 16375;

    // TIMER 2 PERIOD  = 32.768 ms
    IEC0bits.T2IE = 1;          // timer 2 interrupt enable
    IPC1bits.T2IP = 5;      // timer 2 interrupt priority

    T2CONbits.TCKPS = 0b01; // prescale: 1:8
    //PR2 = 16384;

    // TIMER 3 PERIOD ) = ~2 s
    IEC0bits.T3IE = 1;          // timer 3 interrupt enable
    IPC2bits.T3IP = 5;      // timer 3 interrupt priority

    T3CONbits.TCKPS = 0b11; // prescale: 1:256
    //PR3 = 31250;

    // TIMER 4 PERIOD  = 100 ms
    IEC1bits.T4IE = 1;          // timer 4 interrupt enable
    IPC6bits.T4IP = 4;          // timer 4 interrupt priority
    T4CONbits.TCKPS = 2;    // prescale: 1:64
    PR4 = 25000;

    // TIMER 5
    IEC1bits.T5IE = 1;
    IPC7bits.T5IP = 7;
    T5CONbits.TON = 1;
    T5CONbits.TCKPS = 0b01; // prescale: 1:8
}
